/*
  Video for WindowsɂAVIt[̎擾

           2005/ 1/ 6 ˁ@P
*/
#include <windows.h>
#include <vfw.h>

/* BCCŃRpCꍇ́Aȉ̍sRgAEgĂ */
#pragma comment(lib, "vfw32.lib")

/* ǂݍAVIt@C̃pX */
LPCTSTR lpszAviFilePath = "C:\\test.avi";

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

BOOL setAVIInfo(LPCTSTR);
LPVOID loadFrame(LPCTSTR, int);

HWND hwMain;

int iAviWidth, iAviHeight, iAviFrames, iAviIndex;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow) {

	MSG msg;
	WNDCLASSEX wndclass;
	
	wndclass.cbSize        = sizeof(wndclass);
	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = NULL;
	wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = "AVIFRAME";
	wndclass.hIconSm       = NULL;

	RegisterClassEx(&wndclass);

	AVIFileInit();

	CreateWindow ("AVIFRAME", NULL, WS_OVERLAPPEDWINDOW,
	  CW_USEDEFAULT, CW_USEDEFAULT, 500, 568, 
	  NULL, NULL, hInstance, NULL);

	ShowWindow(hwMain, iCmdShow);

	while (GetMessage(&msg, NULL, 0, 0)) { /* bZ[W[v */

		TranslateMessage(&msg);
		DispatchMessage(&msg);

	}

	AVIFileExit();

	return (int)msg.wParam;

}

LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {

	HDC hdc;
	PAINTSTRUCT ps;

	static LPBYTE lpFrame;
	static LPBITMAPINFOHEADER lpbmiHead;
	static LPVOID lpPixels;

	switch (iMsg) {

	case WM_CREATE:

		hwMain = hwnd;

		/* Avȉ擾 */
		if (setAVIInfo(lpszAviFilePath)) {

			lpFrame = (LPBYTE)loadFrame(lpszAviFilePath, 0);

			lpbmiHead = (LPBITMAPINFOHEADER)lpFrame;
			lpPixels = lpFrame + lpbmiHead->biSize;

		}

		return 0;

	/* ENbN1t[i߂ */
	case WM_RBUTTONDOWN:

		if (iAviIndex == iAviFrames - 1) {
			return 0;
		}

		if (lpFrame != NULL) {
			GlobalFree(lpFrame);
		}

		/* t[f[^擾 */
		lpFrame = (LPBYTE)loadFrame(lpszAviFilePath, iAviIndex + 1);

		if (lpFrame != NULL) {

			/* DIB̃|C^ݒ */
			lpbmiHead = (LPBITMAPINFOHEADER)lpFrame;
			lpPixels = lpFrame + lpbmiHead->biSize;

			iAviIndex++;

			InvalidateRgn(hwnd, NULL, FALSE);

		}

		return 0;

	/* NbN1t[߂ */
	case WM_LBUTTONDOWN:

		if (iAviIndex == 0) {
			return 0;
		}

		if (lpFrame != NULL) {
			GlobalFree(lpFrame);
		}

		/* t[f[^擾 */
		lpFrame = (LPBYTE)loadFrame(lpszAviFilePath, iAviIndex - 1);

		if (lpFrame != NULL) {

			/* DIB̃|C^ݒ */
			lpbmiHead = (LPBITMAPINFOHEADER)lpFrame;
			lpPixels = lpFrame + lpbmiHead->biSize;

			iAviIndex--;

			InvalidateRgn(hwnd, NULL, FALSE);

		}

		return 0;

	case WM_PAINT:

		hdc = BeginPaint(hwnd,&ps);

		if (lpFrame != NULL) {
		    StretchDIBits(hdc, 0, 0, lpbmiHead->biWidth, lpbmiHead->biHeight,
			  0, 0, lpbmiHead->biWidth, lpbmiHead->biHeight,
			  lpPixels, (LPBITMAPINFO)lpbmiHead, DIB_RGB_COLORS, SRCCOPY);
		}

		EndPaint(hwnd, &ps);

		return 0;

	case WM_DESTROY : /* I */

		if (lpFrame != NULL) {
			GlobalFree(lpFrame);
		}

		PostQuitMessage(0);

		return 0;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

/* AVȈiTCY/t[jݒ */
BOOL setAVIInfo(LPCTSTR lpszAviFilePath) {

	PAVIFILE pfAvi;
	AVIFILEINFO afAvi;

	/* AVIt@CJ */
	if (AVIFileOpen(&pfAvi, lpszAviFilePath, OF_READ, NULL) != 0) {
		return FALSE;
	}

	/* AVIt@C̏擾 */
	AVIFileInfo(pfAvi, &afAvi, sizeof(AVIFILEINFO));

	/* t[̃TCY擾 */
	iAviWidth = afAvi.dwWidth;
	iAviHeight = afAvi.dwHeight;

	/* t[擾 */
	iAviFrames = afAvi.dwLength;

	AVIFileRelease(pfAvi);

	return TRUE;

}

/* AVIt@Ct[ǂݍ */
LPVOID loadFrame(LPCTSTR lpszAviFilePath, int iIndex) {

	PAVIFILE pfAvi;
	PAVISTREAM psAvi;
	PGETFRAME pgfFrame;
	BITMAPINFOHEADER bmiFrame;
	char aszInfo[256];

	LPVOID lpTmp, lpData;

	/* AVIt@CJ */
	if (AVIFileOpen(&pfAvi, lpszAviFilePath, OF_READ, NULL) != 0) {
		return NULL;
	}

	ZeroMemory(&bmiFrame, sizeof(BITMAPINFOHEADER));

	/* 擾DIB̌`ݒ */
	bmiFrame.biSize = sizeof(BITMAPINFOHEADER);
	bmiFrame.biPlanes = 1;
	bmiFrame.biBitCount = 24;
	bmiFrame.biWidth = iAviWidth;
	bmiFrame.biHeight = iAviHeight;

	/* AVĨrfIXg[擾 */
	AVIFileGetStream(pfAvi, &psAvi, streamtypeVIDEO, 0);

	pgfFrame = AVIStreamGetFrameOpen(psAvi, &bmiFrame);

	/* t[iIndex擾 */
	lpTmp = AVIStreamGetFrame(pgfFrame, iIndex);

	/* t[f[^pobt@m */
	lpData = GlobalAlloc(GPTR, sizeof(BITMAPINFOHEADER) + iAviWidth * iAviHeight * 3);

	/* t[f[^obt@ɃRs[ */
	CopyMemory(lpData, lpTmp, sizeof(BITMAPINFOHEADER) + iAviWidth * iAviHeight * 3);

	AVIStreamGetFrameClose(pgfFrame);

	/* Xg[ */
	AVIStreamRelease(psAvi);

	/* AVIt@C */
	AVIFileRelease(pfAvi);

	/* EChẼ^Cgo[Ƀt[\ */
	wsprintf(aszInfo, "t[ʒu %d/%d", iIndex + 1, iAviFrames);
	SetWindowText(hwMain, aszInfo);

	/* t[DIBC[WԂ */
	return lpData;

}
